<html>
<head><title>ODI Calib. Pipeline System Sequence Diagram</title></head>
<body>

<center>
<h4> Figure 1: ODI Calib. Pipeline System Sequence Diagram </h4>
<div class=wsd wsd_style="qsd"><pre>
participant "Operator\nPS UI" as PSUI
participant "PSQ DB" as PSQ
participant PSA
participant DataEngine/\nXMCCat as DE
participant OGCE
note over PSUI, OGCE
Dataset processing is triggered automatically based on observing block end times or manually by an operator.
end note
alt automatic trigger
PSA->PSQ: Check pending and\nresubmit datasets
PSA->PSA: Poll until end\ntime reached
else manual trigger
PSUI->PSQ: Identify dataset
PSUI->PSA: Process dataset
end
PSA->DE: Process dataset
PSA->PSQ: Mark submitted
DE->OGCE: Start workflow
note over PSUI, OGCE
    Monitor workflow by DE and PSA and review results.
    Whether PSA monitors OGCE directly or through DE is open.
end note
OGCE->PSA: Subset started
PSA->PSQ: Enter subset
OGCE->DE: Operator review\nsubset data
DE->PSA: Operator review\nsubset data URI
PSA->PSQ: Operator review\nsubset data URI
OGCE->PSA: Subset finished
PSA->PSQ: Enter subset\nfinished
note over PSUI, OGCE: etc.
OGCE->DE: Dataset finished
DE->PSA: Dataset finished
PSA->PSQ: Dataset finished
note over PSUI, OGCE: Process more datasets.
opt This is asynchronous for completed subsets either as soon as subset completes or well after dataset completes.
PSUI->PSQ: Get review URI
PSUI->DE: Review subset data
alt If not already archived and review good.
PSUI->DE: Archive subset data
PSUI->PSQ: Mark archived.
PSUI->PSUI: Notify PI
else Mark for reprocessing
PSUI->PSQ: Set dataset status\nto resubmit
end
end
</pre></div><script type="text/javascript"
src="http://www.websequencediagrams.com/service.js"></script>
</center>

</body></html>

